Unit DE18R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE16_p;

procedure DE18R(F :Proc_F_DE; M :Integer; IORDER :Integer;
                XN :Real; var YN :Array of Real;
                var DYN :Array of Real; HMIN :Real; EPS :Real;
                P :Real; var H :Real; var X :Real;
                var YX :Array of Real; var Z :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);

implementation

procedure DE18R(F :Proc_F_DE; M :Integer; IORDER :Integer;
                XN :Real; var YN :Array of Real;
                var DYN :Array of Real; HMIN :Real; EPS :Real;
                P :Real; var H :Real; var X :Real;
                var YX :Array of Real; var Z :Array of Real;
                var DF :Array of Real; var RFN :Array of Real;
                var RF :Array of Real; var R :Array of Real;
                var IERR :Integer);
var
I :Integer;
RH,RH1 :Real;
BHMIN :Boolean;
COEF :Array [0..4] of Real;
const
HALF :Real = 0.5;
TWO :Real = 2.0;
CFNT1 :Real = 0.08333333333333333;
CFNT2 :Real = 1.125;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140;
begin
{   DATA  FORTRAN  }
COEF[0] := 6.0;
COEF[1] := 1.5;
COEF[2] := 0.2333333333333333;
COEF[3] := 0.1416666666666667;
COEF[4] := 12.0;
IERR := 0;
BHMIN := False;
F(XN,YN,RFN,M);
RH := CFNT1*H;
RH1 := CFNT2*H;
for I:=1 to M do
 begin
  RFN[I-1] := RH*RFN[I-1];
_10:
 end;
_20:
for I:=1 to M do
 begin
  R[I-1] := DYN[I-1] + COEF[0]*RFN[I-1];
{   ************  BCEHE Y1  ********** }
  YX[I-1] := YN[I-1] + H*R[I-1];
_30:
 end;
X := XN + H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := RH*DF[(I-1)+0*M];
  DF[(I-1)+1*M] := DF[(I-1)+0*M] - RFN[I-1];
  Z[I-1] := R[I-1] + COEF[4]*DF[(I-1)+0*M];
{   **********  BCEHE Y2  ********** }
  YX[I-1] := YX[I-1] + H*Z[I-1];
_40:
 end;
X := X + H;
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RH*RF[I-1];
  RF[I-1] := RF[I-1] - DF[(I-1)+0*M];
  DF[(I-1)+2*M] := RF[I-1] - DF[(I-1)+1*M];
  RF[I-1] := DF[(I-1)+1*M] - DF[(I-1)+2*M];
  Z[I-1] := R[I-1] + TWO*RF[I-1] + COEF[1]*DF[(I-1)+2*M];
{   **********  BCEHE Y1  ********** }
  YX[I-1] := YN[I-1] + H*Z[I-1];
_50:
 end;
X := XN + H;
F(X,YX,DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := RH*DF[(I-1)+0*M];
  DF[(I-1)+1*M] := DF[(I-1)+0*M] - RFN[I-1];
  Z[I-1] := Z[I-1] + COEF[4]*DF[(I-1)+0*M] + DF[(I-1)+2*M];
{   **********  BCEHE Y2  ********** }
  YX[I-1] := YX[I-1] + H*Z[I-1];
_60:
 end;
X := X + H;
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RH*RF[I-1];
  DF[(I-1)+2*M] := RF[I-1] - DF[(I-1)+0*M];
  DF[(I-1)+3*M] := DF[(I-1)+2*M] - DF[(I-1)+1*M];
  Z[I-1] := Z[I-1] + COEF[4]*RF[I-1] + DF[(I-1)+3*M];
{   **********  BCEHE Y3  ********** }
  YX[I-1] := YX[I-1] + H*Z[I-1];
_70:
 end;
X := X + H;
F(X,YX,DF[0+4*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+4*M] := RH*DF[(I-1)+4*M];
  RF[I-1] := DF[(I-1)+4*M] - RF[I-1];
  DF[(I-1)+2*M] := RF[I-1] - DF[(I-1)+2*M];
  Z[I-1] := Z[I-1] + COEF[4]*DF[(I-1)+4*M] + DF[(I-1)+2*M];
{   **********  BCEHE Y4  ********** }
  YX[I-1] := YX[I-1] + H*Z[I-1];
_80:
 end;
X := X + H;
F(X,YX,Z,M);
for I:=1 to M do
 begin
  DF[(I-1)+4*M] := RH*Z[I-1] - DF[(I-1)+4*M];
  DF[(I-1)+4*M] := DF[(I-1)+4*M] - RF[I-1];
  RF[I-1] := DF[(I-1)+2*M] - DF[(I-1)+3*M];
  DF[(I-1)+4*M] := DF[(I-1)+4*M] - DF[(I-1)+2*M];
  DF[(I-1)+4*M] := DF[(I-1)+4*M] - RF[I-1];
  DF[(I-1)+2*M] := DF[(I-1)+3*M] - RF[I-1] + DF[(I-1)+4*M];
  DF[(I-1)+3*M] := RF[I-1] - TWO*DF[(I-1)+4*M];
{   **********  AKOHEHO BCEHE POHTA  ********** }
  Z[I-1] := R[I-1] + TWO*DF[(I-1)+1*M] - HALF*DF[(I-1)+2*M] - COEF[2]*DF[(I-1)+3*M]
    - COEF[3]*DF[(I-1)+4*M];
{   **********  BCEHE Y1  ********** }
  YX[I-1] := YN[I-1] + H*Z[I-1];
  R[I-1] := RH1*DF[(I-1)+4*M];
  if ( Abs(YX[I-1]) >  P ) 
   then R[I-1] := R[I-1]/YX[I-1];
  if ( Abs(R[I-1]) >  EPS ) 
   then goto _100;
_90:
 end;
X := XN + H;
goto _140;
_100:
if ( not  BHMIN ) 
 then goto _110;
IERR := 65;
goto _140;
_110:
H := HALF*H;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _120;
H := Sign(HMIN,H);
BHMIN := True;
_120:
RH := HALF*RH;
RH1 := HALF*RH1;
for I:=1 to M do
 begin
  RFN[I-1] := HALF*RFN[I-1];
_130:
 end;
goto _20;
_140:
if ( IERR <>  0 ) 
 then UTDE16(IERR,18);
end;

end.
