Unit DE48RP_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure DE48RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real; var ZP :Array of Real;
                var Z :Array of Real);

implementation

procedure DE48RP(M :Integer; IORDER :Integer; ALP :Real;
                var DF :Array of Real; var ZP :Array of Real;
                var Z :Array of Real);
var
I,I1,J,L :Integer;
ALP2,ALP3,ALP4,ALPM1,R :Real;
COEF :Array [0..9] of Real;
COEFH :Array [0..4] of Real;
COEFZ :Array [0..3] of Real;
COEFZG :Array [0..4] of Real;
const
HALF :Real = 0.5;
ONE :Real = 1.0;
TWO :Real = 2.0;
CFNT1 :Real = 0.5833333;
CFNT2 :Real = 1.571429;
SYS037 :Real = 0.33333333333333333333333333333333;
CFNT3 :Real = 6.0;
CFNT4 :Real = 0.025;
CFNT5 :Real = 0.03333333;
CFNT6 :Real = 0.008333333;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120;
begin
{   DATA  FORTRAN  }
COEFH[0] := 0.03125;
COEFH[1] := 0.0625;
COEFH[2] := 1.5;
COEFH[3] := 0.125;
COEFH[4] := 0.25;
COEFZ[0] := 3.0;
COEFZ[1] := 0.3125;
COEFZ[2] := 0.15625;
COEFZ[3] := 0.0984375;
if ( ALP =  ONE ) 
 then goto _120;
if ( ALP =  HALF ) 
 then goto _50;
if ( ALP =  TWO ) 
 then goto _70;
ALP2 := ALP*ALP;
ALP3 := ALP2*ALP;
ALP4 := ALP3*ALP;
ALPM1 := ALP - ONE;
COEF[0] := ALP2;
COEF[1] := -COEF[0]*HALF*ALPM1;
COEF[2] := -COEF[1]*SYS037*(ALP - TWO);
COEF[3] := -COEF[2]*COEFH[4]*(ALP - 3.0);
COEF[4] := ALP3;
COEF[5] := -ALP3*ALPM1;
COEF[6] := -COEF[5]*CFNT1*(ALP - CFNT2);
COEF[7] := ALP4;
COEF[8] := -ALP4*COEFH[2]*ALPM1;
COEF[9] := ALP4*ALP;
COEFZG[0] := -ALPM1*CFNT3;
COEFZG[1] := ALPM1*(TWO*ALP + TWO);
COEFZG[2] := ALPM1*HALF*(-ALP2 + ALP + ONE);
COEFZG[3] := ALPM1*CFNT5*(3.0*ALP3 - 12.0*ALP2 + 8.0*
    ALP + 8.0);
COEFZG[4] := ALPM1*CFNT6*(-TWO*ALP4 + 16.0*ALP3 - 39.0*
    ALP2 + 21.0*ALP + 21.0);
for I:=1 to M do
 begin
  for I1:=1 to 5 do
   begin
    ZP[I-1] := ZP[I-1] + COEFZG[I1-1]*DF[(I-1)+(I1-1)*M];
_10:
   end;
{   **********  EPECBAEM 1- EMEHT 1-OO CTOA  ********** }
  DF[(I-1)+0*M] := ALP*DF[(I-1)+0*M];
{   **********  EPECBAEM 1- EMEHT J-OO CTOA  ********** }
  I1 := 0;
  for J:=2 to IORDER do
   begin
    R := 0.0;
    for L:=J to IORDER do
     begin
      I1 := I1 + 1;
      R := R + COEF[I1-1]*DF[(I-1)+(L-1)*M];
_20:
     end;
    DF[(I-1)+(J-1)*M] := R;
_30:
   end;
_40:
 end;
goto _120;
_50:
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := ALP*DF[(I-1)+0*M];
  DF[(I-1)+4*M] := COEFH[0]*DF[(I-1)+4*M];
  DF[(I-1)+3*M] := COEFH[1]*DF[(I-1)+3*M] + COEFH[2]*DF[(I-1)+4*M];
  DF[(I-1)+2*M] := COEFH[3]*DF[(I-1)+2*M] + DF[(I-1)+3*M] - COEFH[4]*DF[(I-1)+4*M];
  DF[(I-1)+1*M] := COEFH[4]*DF[(I-1)+1*M] + HALF*DF[(I-1)+2*M];
  ZP[I-1] := ZP[I-1] + CFNT3*(DF[(I-1)+0*M] - DF[(I-1)+1*M]) + HALF*
    DF[(I-1)+2*M] - CFNT4*DF[(I-1)+4*M];
_60:
 end;
goto _120;
_70:
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := ALP*DF[(I-1)+0*M];
  DF[(I-1)+1*M] := 4.0*DF[(I-1)+1*M] - TWO*DF[(I-1)+2*M];
  DF[(I-1)+2*M] := 8.0*(DF[(I-1)+2*M] - DF[(I-1)+3*M]) + TWO*DF[(I-1)+4*M];
  DF[(I-1)+3*M] := 16.0*DF[(I-1)+3*M] - 24.0*DF[(I-1)+4*M];
  DF[(I-1)+4*M] := 32.0*DF[(I-1)+4*M];
_80:
 end;
if ( _COM48R.elm4 =  1 ) 
 then goto _100;
for I:=1 to M do
 begin
  ZP[I-1] := HALF*(Z[I-1] + ZP[I-1]);
_90:
 end;
goto _120;
_100:
for I:=1 to M do
 begin
  ZP[I-1] := ZP[I-1] - COEFZ[0]*DF[(I-1)+0*M] + COEFH[2]*DF[(I-1)+1*M] +
    COEFZ[1]*DF[(I-1)+2*M] + COEFZ[2]*DF[(I-1)+3*M] + COEFZ[3]*
    DF[(I-1)+4*M];
_110:
 end;
_120:
end;

end.
