Unit DE48R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE48RP_p, DE18R_p, DE28RS_p, UTDE16_p;

procedure DE48R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; HMAX :Real; EPS :Real;
                P :Real; var YX :Array of Real; var X :Real;
                var Z :Array of Real; var H :Real; var BUL :Boolean;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var ZP :Array of Real;
                var IERR :Integer);

implementation

procedure DE48R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; HMAX :Real; EPS :Real;
                P :Real; var YX :Array of Real; var X :Real;
                var Z :Array of Real; var H :Real; var BUL :Boolean;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var ZP :Array of Real;
                var IERR :Integer);
var
I,IN_,JER,K,KP1 :Integer;
ALP,EPS1,EPS2,RH :Real;
BCOR,BHMIN :Boolean;
const
HALF :Real = 0.5;
TWO :Real = 2.0;
CFNT1 :Real = 0.08333333333333333;
CFNT2 :Real = 0.015625;
CFNT3 :Real = 12.0;
CFNT4 :Real = 20.0;
CFNT5 :Real = -0.05;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280;
begin
EPS1 := CFNT4*EPS;
EPS2 := CFNT2*EPS;
BHMIN := False;
_COM48R.elm4 := 1;
if ( JSTART >=  0 ) 
 then goto _50;
if ( IERR <  65 ) 
 then goto _20;
if ( Abs(H) <  Abs(_COM48R.elm2) ) 
 then goto _10;
H := _COM48R.elm2*HALF;
_10:
IERR := 0;
goto _80;
_20:
if ( _COM48R.elm1*TWO =  _COM48R.elm2 ) 
 then DE48RP(M,5,HALF,DF,Z,ZP);
for K:=1 to 4 do
 begin
  KP1 := K + 1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M] - DF[(I-1)+(KP1-1)*M];
_30:
   end;
_40:
 end;
ALP := H/_COM48R.elm1;
IERR := 0;
goto _90;
_50:
_COM48R.elm3 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
  ZP[I-1] := Z[I-1];
_60:
 end;
IERR := 0;
if ( JSTART >  0 ) 
 then goto _70;
F(X,YX,RF,M);
{   **********  BOHEHE CAMOO EPBOO AA, T.E. PAOH  ********** }
DE18R(F,M,5,_COM48R.elm3,YP,ZP,HMIN,EPS,P,H,X,YX,Z,DF,RFN,RF,
     DELTY,JER);
if ( JER <>  0 ) 
 then IERR := 66;
_COM48R.elm1 := H;
goto _280;
_70:
if ( H =  _COM48R.elm2 ) 
 then goto _100;
_80:
ALP := H/_COM48R.elm2;
_90:
DE48RP(M,5,ALP,DF,ZP,Z);
_100:
for I:=1 to M do
 begin
  RF[I-1] := DF[(I-1)+2*M] + DF[(I-1)+3*M];
  Z[I-1] := ZP[I-1] + CFNT3*DF[(I-1)+0*M] + RF[I-1];
  YX[I-1] := YP[I-1] + H*Z[I-1];
  DELTY[I-1] := -RF[I-1] - DF[(I-1)+0*M] - DF[(I-1)+1*M];
_110:
 end;
RH := CFNT1*H;
IN_ := 1;
X := _COM48R.elm3 + H;
_120:
BCOR := True;
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RH*RF[I-1];
{   **********  BEHA KOPPEK  POMEYTOHO EPEMEHHO Z  ***** }
  DELTY[I-1] := DELTY[I-1] + RF[I-1];
  Z[I-1] := Z[I-1] + DELTY[I-1];
{   **********  BEHA KOPPEK  PEEH YX  ********** }
  DELTY[I-1] := H*DELTY[I-1];
  YX[I-1] := YX[I-1] + DELTY[I-1];
  if ( Abs(YX[I-1]) >  P ) 
   then DELTY[I-1] := DELTY[I-1]/YX[I-1];
_130:
  if ( Abs(DELTY[I-1]) >  EPS ) 
   then BCOR := False;
_140:
 end;
if ( BCOR ) 
 then goto _210;
if ( IN_ =  2 ) 
 then goto _170;
for I:=1 to M do
 begin
  if ( Abs(DELTY[I-1]) >  EPS1 ) 
   then goto _170;
_150:
 end;
IN_ := IN_ + 1;
for I:=1 to M do
 begin
  DELTY[I-1] := -RF[I-1];
_160:
 end;
{   **********  EM HA BOHEHE BTOPO KOPPEK  ********** }
goto _120;
_170:
if ( not  BHMIN ) 
 then goto _180;
IERR := 65;
goto _280;
{   **********  EEHE AA OOAM  ********** }
_180:
H := HALF*H;
BUL := False;
if ( Abs(H) >  Abs(HMIN) ) 
 then goto _190;
RH := Sign(HMIN,H);
ALP := RH*HALF/H;
H := RH;
BHMIN := True;
goto _200;
_190:
ALP := HALF;
_200:
DE48RP(M,5,ALP,DF,ZP,Z);
{   **********  EM HA OBTOPEHE OOBHHOO AA  ********** }
goto _100;
{   **********  TOHOCT OCTHYTA OCE OHO  BYX KOPPEK  ***** }
_210:
F(X,YX,RF,M);
for I:=1 to M do
 begin
  RF[I-1] := RH*RF[I-1];
_220:
 end;
DE28RS(M,5,RF,DF,DELTY);
_COM48R.elm1 := H;
for I:=1 to M do
 begin
  DELTY[I-1] := CFNT5*DF[(I-1)+4*M];
{   **********  YTOHEHE PEEH  POMEYTOHO EPEMEHHO  ********** }
  Z[I-1] := Z[I-1] + DELTY[I-1];
  DELTY[I-1] := H*DELTY[I-1];
  YX[I-1] := YX[I-1] + DELTY[I-1];
_230:
 end;
_240:
for I:=1 to M do
 begin
  if ( Abs(YX[I-1]) >  P ) 
   then DELTY[I-1] := DELTY[I-1]/YX[I-1];
  if ( Abs(DELTY[I-1]) >  EPS2 ) 
   then goto _280;
_250:
 end;
{   **********  YBOEHE AA  ********** }
H := TWO*H;
_COM48R.elm4 := 2;
if ( Abs(H) <=  Abs(HMAX) ) 
 then goto _260;
ALP := Sign(HMAX,H)*TWO/H;
H := Sign(HMAX,H);
goto _270;
_260:
ALP := TWO;
_270:
DE48RP(M,5,ALP,DF,Z,ZP);
_280:
if ( IERR <>  0 ) 
 then UTDE16(IERR,48);
JSTART := 1;
_COM48R.elm2 := H;
end;

end.
